

#include <allegro.h>
#include <iostream>
#include <vector>
#include <sstream>
#include <math.h>
#include <list>
#include <map>
#include <fstream>
#include <stack>
#include <algorithm>
#include <queue>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif


using namespace std;


typedef double num;

const int SCREEN_WIDTH=80;
const int SCREEN_HEIGHT=60;
const int TILE_HEIGHT=26;
const int TILE_WIDTH=25;
const int FRAMERATE=30;
int bltime;
int endmenutimer;
bool endmode;

const int RADIUS = 3;
//const int BASERADIUS = 15;

struct Pos {
	float x;
	float y;
};


int magenta;
int red;
int black;
int white;
int green;
int blue;
int yellow;
int bgcol;

int target[2];
bool inbase[2];

Pos pos[2];
Pos base[2];

const int CIRCLECOUNT=20;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];

//used for targetting numerical enemies


BITMAP* buffer;
BITMAP* stagebg[3];
BITMAP* tilemap;
BITMAP* blah;

FONT* f;

#include "sound.hpp"
#include "misc.hpp"
#include "timer.hpp"

const int ts=13;
bool quit=false;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;


void cutbars()
{
	rectfill(buffer, 0, 0, SCREEN_WIDTH, 2, black);
	rectfill(buffer, 0, SCREEN_HEIGHT-3, SCREEN_WIDTH, SCREEN_HEIGHT, black);
}

struct State 
{
	int x;
	int frame;
};

State wife;
State husband;
State daughter;

#define STARTANIM \
	int j=0; \
	if (false) {
#define DURATION(x) } else if (t<(j+=x)) {
#define ENDANIM } else return true; return false;
#define POSITION(entity,posx,posy,frameno) \
	entity.x=posx;\
	entity.y=posy;\
	entity.frame=frameno;
#define DRAW(frame,x) masked_blit(tilemap, buffer, frame*TILE_WIDTH, 0, x, 29, TILE_WIDTH, TILE_HEIGHT);
#define LEFT(x) textout_ex(buffer, f, x, 1, 19, makecol(255,255,255), -1);
#define RIGHT(x) textout_right_ex(buffer, f, x, SCREEN_WIDTH-2, 19, makecol(255,255,255), -1);
#define CUTBARS cutbars();
#define CENTER(x) textout_centre_ex(buffer, f, x, SCREEN_WIDTH/2, SCREEN_HEIGHT/2-5, white, -1);

#define SCENTER(x) textout_centre_ex(buffer, f, x, SCREEN_WIDTH/2, 19, white, -1);

enum Lude {Prelude, Postlude, PostludeAlt, AfterStay,AfterLeave};

template<int scene, Lude lude>
bool anim(int t);

template<>
bool anim<0,Prelude>(int t)
{
	STARTANIM
	
	DURATION(50)
	DRAW(1,10)
	DRAW(11,30)
	
	DURATION(50)
	RIGHT("what's wrong?");
	DRAW(1,10)
	DRAW(11,30)
	
	
	DURATION(50)
	LEFT("i've seen you.");
	DRAW(1,10)
	DRAW(11,30)
	
	
	DURATION(50)
	RIGHT("what're you on about?");
	DRAW(1,10)
	DRAW(11,30)
	
	
	DURATION(50)
	LEFT("don't play games!");
	DRAW(1,10)
	DRAW(11,30)
	
	
	DURATION(50)
	LEFT("looking at other men!");
	DRAW(1,10)
	DRAW(11,30)
	
	
	DURATION(20)
	RIGHT("never!");
	DRAW(1,10)
	DRAW(11,30)
	
	
	
	DURATION(50)
	LEFT("don't lie to me!");
	DRAW(1,10)
	DRAW(11,30)
	
	
	
	DURATION(40)
	RIGHT("...please...");
	DRAW(1,10)
	DRAW(11,30)
	
	DURATION(30)
	RIGHT("...not now...");
	DRAW(1,10)
	DRAW(11,30)
	
	DURATION(30)
	RIGHT("...not here...");
	DRAW(1,10)
	DRAW(11,30)
	
	DURATION(20)
	DRAW(1,10)
	DRAW(11,30)
	
	
	DURATION(10)
	LEFT("don't tell me what to do!");
	DRAW(1,10)
	DRAW(11,30)
	
	DURATION(40)
	LEFT("don't tell me what to do!");
	DRAW(2,10)
	DRAW(11,30)
	
	ENDANIM
		
}

template<>
bool anim<0,Postlude>(int t)
{
	STARTANIM
	
	DURATION(20)
	DRAW(1,wife.x-15)
	DRAW(10,wife.x)	
	
	DURATION(20)
	DRAW(2,wife.x-15)
	DRAW(10,wife.x)	
	
	DURATION(10)
	DRAW(3,wife.x-10)
	DRAW(10,wife.x)	
	
	DURATION(15)
	DRAW(3,wife.x-10)
	DRAW(9,wife.x)
	
	DURATION(75)
	DRAW(1,wife.x-10)
	DRAW(9,wife.x)
	
	ENDANIM
}

template<>
bool anim<0,AfterLeave>(int t)
{
	STARTANIM
	
	
	DURATION(40)
	CENTER("Beth")
	DURATION(20)
	DURATION(40)
	CENTER("I'm so sorry")
	DURATION(20)
	DURATION(40)
	CENTER("You're everything to me")
	DURATION(60)
	CENTER("But you deserve better")
	DURATION(60)
	DURATION(40)
	CENTER("I will always love you")
	DURATION(40)
	DURATION(40)
	CENTER("My sweet Beth")
	DURATION(120)
	ENDANIM
}



template<>
bool anim<0,AfterStay>(int t)
{
	STARTANIM
	DURATION(50)
	CENTER("Honey")
	DURATION(5)
	DURATION(40)
	CENTER("Beth")
	DURATION(50)
	CENTER("I love you so much")
	DURATION(5)
	DURATION(40)
	CENTER("I'm so sorry")
	DURATION(30)
	DURATION(40)
	CENTER("You're everything to me")
	DURATION(10)
	DURATION(40)
	CENTER("You're my whole life")
	DURATION(40)
	CENTER("It'll never happen again")
	DURATION(20)
	DURATION(80)
	CENTER("I promise")
	DURATION(30)
	ENDANIM
}


template<>
bool anim<1,Prelude>(int t)
{
	STARTANIM
	
	DURATION(60)
	DRAW(1,22)
	DRAW(11,51)
	
	
	DURATION(50)
	DRAW(1,22)
	DRAW(11,51)
	RIGHT("these bills...")
	
	DURATION(50)
	DRAW(1,22)
	DRAW(11,51)
	
	DURATION(50)
	DRAW(1,22)
	DRAW(11,51)
	RIGHT("we're struggling")
	
	DURATION(40)
	DRAW(1,22)
	DRAW(11,51)
	RIGHT("we might not")
	
	DURATION(20)
	DRAW(1,22)
	DRAW(11,51)
	RIGHT("have enough")
	
	DURATION(50)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("shut up!")
	
		 
	DURATION(50)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("what more can i do?")
		 
	DURATION(50)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("i work and i sleep")
	
	DURATION(50)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("that's all i do")
		 
	DURATION(50)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("and all so that...")
	
	DURATION(25)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("after spending")
	
	DURATION(25)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("all my money")
		 
	DURATION(40)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("you complain to me")
	
	DURATION(60)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("we don't have enough!")
	
	DURATION(25)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("what sort")
	
	DURATION(25)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("of marriage")
	
	DURATION(30)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("is this?")
	
	DURATION(30)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("you won't even")
	
	DURATION(30)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("sleep with me!")
	
	DURATION(30)
	DRAW(1,22)
	DRAW(11,51)
	RIGHT("that's not fair!")
	
	DURATION(50)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("you don't love me")
	
	DURATION(25)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("you just want")
	
	DURATION(25)
	DRAW(1,22)
	DRAW(11,51)
	LEFT("an easy ride!")
	
	DURATION(10)
	DRAW(1,22)
	DRAW(11,51)
	RIGHT("please!")
	
	DURATION(10)
	DRAW(1,32)
	DRAW(11,51)
	RIGHT("please!")
	
	DURATION(5)
	DRAW(1,42)
	DRAW(11,51)
	RIGHT("please!")
	
	DURATION(5)
	DRAW(1,42)
	DRAW(11,51)
	
	DURATION(10)
	DRAW(2,42)
	DRAW(11,51)
	
	DURATION(10)
	DRAW(3,45)
	DRAW(11,51)
	
	DURATION(90)
	DRAW(0,40)
	DRAW(9,51)
	
	ENDANIM
}

template<>
bool anim<1,Postlude>(int t)
{
	STARTANIM
	
	DURATION(40)
	DRAW(1,wife.x-10)
	DRAW(9,wife.x)	
	
	DURATION(25)
	DRAW(4,wife.x-10)
	DRAW(9,wife.x)	
	
	
	DURATION(60)
	DRAW(5,wife.x-10)
	DRAW(9,wife.x)	
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(15)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(15)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(15)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(15)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(15)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(15)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(15)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(15)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(10)
	DRAW(7,wife.x-7)
	
	DURATION(10)
	DRAW(6,wife.x-7)
	
	DURATION(15)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)
	
	DURATION(10)
	DRAW(7,wife.x-7)
	
	DURATION(10)
	DRAW(6,wife.x-7)
	
	DURATION(8)
	DRAW(7,wife.x-7)
	
	DURATION(8)
	DRAW(6,wife.x-7)
	
	DURATION(8)
	DRAW(7,wife.x-7)
	
	DURATION(8)
	DRAW(6,wife.x-7)
	
	DURATION(40)
	DRAW(7,wife.x-7)
	
	DURATION(15)
	DRAW(6,wife.x-7)

	DURATION(60)
	DRAW(5,wife.x-10)
	DRAW(9,wife.x)	
	
	DURATION(120)
	DRAW(5,wife.x-10)
	DRAW(9,wife.x)	
	
	DURATION(240)
	DRAW(5,wife.x-10)
	DRAW(8,wife.x)
	
	ENDANIM
}


template<>
bool anim<1,AfterStay>(int t)
{
	STARTANIM
	DURATION(30)
	DURATION(60)
	CENTER("Beth")
	DURATION(60)
	DURATION(60)
	CENTER("Beth")
	DURATION(60)
	DURATION(60)
	CENTER("I'll never forgive myself")
	DURATION(60)
	DURATION(60)
	CENTER("You are an angel")
	DURATION(60)
	DURATION(60)
	CENTER("I'm so disguisted")
	DURATION(60)
	CENTER("with myself")
	DURATION(120)
	CENTER("Beth")
	DURATION(120)
	DURATION(120)
	CENTER("My sweet sweet beth")
	DURATION(120)


	ENDANIM
}


template<>
bool anim<1,AfterLeave>(int t)
{
	STARTANIM
	DURATION(60)
	DURATION(60)
	CENTER("Beth")
	DURATION(60)
	DURATION(60)
	CENTER("I've broken you")
	DURATION(60)
	DURATION(60)
	CENTER("You were so lovely")
	DURATION(60)
	DURATION(60)
	CENTER("And now...")
	DURATION(60)
	DURATION(60)
	CENTER("There're no words...")
	DURATION(140)
	DURATION(140)
	CENTER("...Beth")
	DURATION(140)
	DURATION(140)
	CENTER("...dear Beth...")
	DURATION(140)
	
	
	ENDANIM
}




template<>
bool anim<2,Prelude>(int t)
{
	
	STARTANIM
	
	DURATION(30)
	DRAW(10,72)
	DRAW(1,21)
	DRAW(12,40)
	
	DURATION(30)
	LEFT("You're not going out")
	DRAW(10,72)
	DRAW(1,21)
	DRAW(12,40)
	
	DURATION(25)
	LEFT("like that!")
	DRAW(10,72)
	DRAW(1,21)
	DRAW(12,40)
	
	DURATION(50)
	SCENTER("Try stop me!")
	DRAW(10,72)
	DRAW(1,21)
	DRAW(12,40)
	
	DURATION(30)
	LEFT("Not while you're")
	DRAW(10,72)
	DRAW(1,21)
	DRAW(12,40)
	
	DURATION(30)
	LEFT("in this house!")
	DRAW(10,72)
	DRAW(1,21)
	DRAW(12,40)
	
	DURATION(50)
	SCENTER("Fuck you!")
	DRAW(10,72)
	DRAW(1,21)
	DRAW(12,40)
	
	
	DURATION(50)
	SCENTER("Fuck you!")
	DRAW(10,72)
	DRAW(2,26)
	DRAW(12,40)
	
	ENDANIM
}

template<>
bool anim<2,Postlude>(int t)
{
	STARTANIM
	
	DURATION(40)
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(12,40)
	
	DURATION(5)
	DRAW(10,wife.x)
	DRAW(3,26)
	DRAW(12,40)
	
	DURATION(5)
	DRAW(10,wife.x)
	DRAW(3,26)
	DRAW(13,40)
	
	DURATION(5)
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(13,40)
	
	DURATION(60)
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(14,40)
	
	DURATION(60)
	SCENTER("Mom...")
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(14,40)
	
	DURATION(40)
	SCENTER("You just stood there")
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(14,40)
	
	DURATION(40)
	SCENTER("and let him hit me.")
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(14,40)
	
	DURATION(40)
	SCENTER("No better than him!")
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(15,40)
	
	DURATION(60)
	SCENTER("No better than him!")
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(15,40)
	
	DURATION(120)
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(15,40)
	
	DURATION(240)
	DRAW(10,wife.x)
	DRAW(2,26)
	DRAW(16,40)
	
	ENDANIM
}


template<>
bool anim<2,PostludeAlt>(int t)
{
	STARTANIM
	
	DURATION(30)
	SCENTER("Stop it!")
	DRAW(10,wife.x)
	DRAW(2,wife.x-15)
	DRAW(12,wife.x+15)
	
	DURATION(10)
	DRAW(10,wife.x)
	DRAW(3,wife.x-15)
	DRAW(12,wife.x+15)
	
	DURATION(10)
	DRAW(9,wife.x)
	DRAW(2,wife.x-15)
	DRAW(12,wife.x+15)
	
	DURATION(30)
	DRAW(9,wife.x)
	DRAW(1,wife.x-12)
	DRAW(12,wife.x+15)
	
	
	DURATION(30)
	SCENTER("Mom!")
	DRAW(9,wife.x)
	DRAW(1,wife.x-12)
	DRAW(12,wife.x+15)
	
	
	DURATION(30)
	SCENTER("Mom!")
	DRAW(9,wife.x)
	DRAW(1,wife.x-20)
	DRAW(14,wife.x-5)
		
	DURATION(60)
	DRAW(9,wife.x)
	DRAW(1,wife.x-20)
	DRAW(14,wife.x-5)
	
	DURATION(30)
	SCENTER("Are you ok?")
	DRAW(9,wife.x)
	DRAW(1,wife.x-20)
	DRAW(14,wife.x-5)
	
	DURATION(360)
	DRAW(9,wife.x)
	DRAW(1,wife.x-20)
	DRAW(14,wife.x-5)
	
	ENDANIM
}


template<>
bool anim<2,AfterStay>(int t)
{
	STARTANIM
	
	ENDANIM
}


template<>
bool anim<2,AfterLeave>(int t)
{
	STARTANIM
	
	ENDANIM
}


template<int scene, Lude lude>
class AnimLoop
	{
	public:
		static void initialize()
		{
			escpressed=false;
			bltime=0;
			finishedtitle=false;
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];
			bltime++;
		}
		static void draw()
		{		
			if (lude==AfterStay||lude==AfterLeave)
				clear_to_color(buffer,bgcol);
			else
				blit(stagebg[scene],buffer,0,0,0,0,SCREEN_WIDTH,SCREEN_HEIGHT);
			
			CUTBARS
			
			if (anim<scene,lude>(bltime))
				finishedtitle=true;
		}
	};

template<int t>
class ChoiceLoop
	{
	private:
		static bool begin;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static unsigned int selected;
		static void initialize()
		{
			endmode=false;
			endmenutimer=0;
			
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			
		}
		
		static void logic()
		{
			
			if (endmenutimer>0)
			{
				endmenutimer--;
				
				
				return;
			}
			
			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];
			
			
			
			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+1)%2;
					playsample(1);
					upheld=true;
				}
			}
			else
				upheld=false;
			
			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%2;
					playsample(1);
					downheld=true;
				}
			}
			else
				downheld=false;
			
			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						begin=true;
						endmenutimer=40;
						playsample(0);
					}
					else
					{
						begin=true;
						playsample(0);
						endmenutimer=40;
					}
				}
			}
			else
				spaceheld=false;
			
		}
		
		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}
		
		static void draw()
		{
            clear_to_color(buffer,bgcol);
			
			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}
			
			if (selected==0)
			{
				if (endmenutimer%2==0)
					textout_ex(buffer,f,"  I should stay...            ",15,30,bgcol,makecol(255,255,255));
				textout_ex(buffer,f,"  I should leave...            ",15,40,makecol(255,255,255),-1);
			}
			else
			{
				textout_ex(buffer,f,"  I should stay...            ",15,30,makecol(255,255,255),-1);
				
				if (endmenutimer%2==0)
					textout_ex(buffer,f,"  I should leave...            ",15,40,bgcol,makecol(255,255,255));
			}
			
		}
		
	};


template<int i>
bool ChoiceLoop<i>::begin=false;
template<int i>
unsigned int ChoiceLoop<i>::selected=0;
template<int i>
bool ChoiceLoop<i>::upheld=false;
template<int i>
bool ChoiceLoop<i>::downheld=false;
template<int i>
bool ChoiceLoop<i>::spaceheld=true;

int leveltimer;

int levelgoal;

bool stoppedfather;

template<int i>
class LevelLoop
	{
	public:
		static void initialize();
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];
			
			if (key[KEY_LEFT]&&wife.x>0&&i!=1)
				wife.x--;
		
			if (key[KEY_RIGHT]&&wife.x<60&&i!=1)
				wife.x++;
			
			leveltimer++;
			
			if (leveltimer>70&&i==0)
				
				husband.x++;
			
			else if (leveltimer>360&&i==1)
				finishedtitle=true;
			
			
			else if (leveltimer>120&&i==2)
			{
				stoppedfather=false;
				finishedtitle=true;
			}
			
			if (i!=1 && wife.x-husband.x<15)
			{
				stoppedfather=true;
				finishedtitle=true;
			}
			
		}
		static void draw()
		{
			blit(stagebg[i],buffer,0,0,0,0,SCREEN_WIDTH,SCREEN_HEIGHT);
			DRAW(wife.frame,wife.x-wife.x%10);
			if (husband.x>0)
				DRAW(husband.frame,husband.x-husband.x%10);
			if (daughter.x>0)
				DRAW(daughter.frame,daughter.x-husband.x%10);
		}
	};

template<>
void LevelLoop<0>::initialize()
{
	leveltimer=0;
	finishedtitle=false;
	wife.x=30;
	wife.frame=10;
	
	husband.x=15;
	husband.frame=1;
	
	daughter.x=-1;
	
}

template<>
void LevelLoop<1>::initialize()
{
	leveltimer=0;
	finishedtitle=false;
	wife.x=50;
	wife.frame=9;
	
	husband.x=40;
	husband.frame=1;
	
	daughter.x=-1;
	
}

template<>
void LevelLoop<2>::initialize()
{	
	stoppedfather=false;
	leveltimer=0;
	finishedtitle=false;
	wife.x=72;
	wife.frame=10;
	
	husband.x=26;
	husband.frame=2;
	
	daughter.x=40;
	daughter.frame=12;

}



template<int i>
class BlackLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			bltime=0;
			finishedtitle=false;
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			bltime++;
			if (bltime>i*FRAMERATE)
			{
				finishedtitle=true;
			}
			
			
			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];
			
		}
		static void draw()
		{
			clear_to_color(buffer, bgcol);
		}
	};


template<class T> void loop();

template<int i>
void doLevel()
{
	escpressed=true;
	finishedtitle=false;

	switch(i)
	{
		case 0:
			playmusic(6);
			break;
		case 1:
			playmusic(2);
			break;
		case 2:
			playmusic(5);
			break;
	};
	
	loop<AnimLoop<i,Prelude> >();
	if (quit) return;
	hifi();
	loop<LevelLoop<i> >();
	if (quit) return;
	
	if (i!=2)
	{
		loop<AnimLoop<i,Postlude> >();
		
		if (quit) return;
		lofi();
		loop<ChoiceLoop<i> >();
		if (quit) return;
		loop<BlackLoop<1> >();
		if (quit) return;
		ultralofi();
		loop<BlackLoop<1> >();
		if (quit) return;	
		if (ChoiceLoop<i>::selected==0)
			loop<AnimLoop<i,AfterStay> >();
		else
			loop<AnimLoop<i,AfterLeave> >();
		
	}
	else
	{
		ultralofi();

		if (stoppedfather)
			loop<AnimLoop<2,PostludeAlt> >();
		else
			loop<AnimLoop<2,Postlude> >();
		
		loop<BlackLoop<1> >();

	}
	


};

bool spacepressed;
int storyprogress;
bool finishedstory;
int pauseafter;



class IntroLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		
			cout<<"\nhey\n";
			playmusic(3);
			cout<<"\nbey\n";
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_ex(buffer, f, "increpare presents", 4, 10+(rand()%200>0?1:0),white, -1);

		}
	};


class TitleLoop
	{
	private:
		static bool begin;
		static unsigned int selected;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static void initialize()
		{
			endmode=false;
			endmenutimer=0;

			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;

		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;

				if (endmenutimer==10)
					stopmusic();

				return;
			}

			if (key[KEY_ESC]&&!escpressed)
				quit=true;
			escpressed=key[KEY_ESC];



			if (key[KEY_UP])
			{
				if (!upheld)
				{
					selected=(selected+1)%2;
					playsample(1);
					upheld=true;
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					selected=(selected+1)%2;
					playsample(1);
					downheld=true;
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						begin=true;
						endmenutimer=40;
						playsample(0);
					}
					else
					{
						quit=true;
						ultrahifi();
						playsample(0);
						endmenutimer=80;
					}
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{
            clear_to_color(buffer,bgcol);

			if ( (endmenutimer>0 && endmenutimer<10))
			{
				return;
			}
			
			if (rand()%200!=0)
				DRAW(0,6);

			textout_right_ex(buffer,f,"beth",79,5,makecol(255,255,255),-1);
			
			if (selected==0)
			{
				if (endmenutimer%2==0)
				textout_ex(buffer,f," START ",20,30,bgcol,makecol(255,255,255));
				textout_ex(buffer,f," Exit ",20,40,makecol(255,255,255),-1);
			}
			else
			{
				textout_ex(buffer,f," Start ",20,30,makecol(255,255,255),-1);

				if (endmenutimer%2==0)
				textout_ex(buffer,f," EXIT ",20,40,bgcol,makecol(255,255,255));
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;
int endtimer=0;

void winlevel()
{
	if (endtimer>0)
		return;

	endtimer=120;
	playmusic(6);

}

void loselevel()
{
	stopmusic();
	endtimer=120;
}


float distsq(Pos a, Pos b)
{
	return ((b.x-a.x)*(b.x-a.x)+(b.y-a.y)*(b.y-a.y));
}

template<class T>
void loop()
{

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;

		}

		T::draw();

        stretch_blit(buffer, screen, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0, 640, 480);

	}
}


void init()
{

	/* initialise everything */
	allegro_init();
	init_sound();

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAMERATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;

	red=makecol(255,0,0);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	bgcol=makecol(76,67,55);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);

	tilemap=load_bmp("bmp/tilemap.bmp",NULL);
	stagebg[0]=load_bmp("bmp/stage0.bmp",NULL);
	stagebg[1]=load_bmp("bmp/stage1.bmp",NULL);
	stagebg[2]=load_bmp("bmp/stage2.bmp",NULL);
    f=load_bitmap_font("bmp/newfont.pcx",NULL,NULL);
	
}

int dir;
int px;
int py;

int main(int argc, char *argv[])
{

	init();


	loop<IntroLoop>();
	
titletag:

	if (rand()%2==0)
		loop<BlackLoop<0> >();
	else
		loop<BlackLoop<1> >();
	
		
	hifi();
	
	loop<TitleLoop>();
	loop<BlackLoop<1> >();

	if (quit)
	goto end;

	doLevel<0>();
	if (quit||ChoiceLoop<0>::selected==1)
		goto titlejump;
	
	doLevel<1>();
	if (quit||ChoiceLoop<1>::selected==1)
		goto titlejump;
	
	doLevel<2>();
	if (quit||ChoiceLoop<2>::selected==1)
		goto titlejump;
	
	
		{
		titlejump:
			quit=false;
			playmusic(3);
			goto titletag;
		}
end:
	quit=false;
	stopmusic();
	loop<BlackLoop<1> >();
	return 0;

}
END_OF_MAIN()
