/*
 *  sound.hpp
 *  Template
 *
 *  Created by increpare on 16/01/2009.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <aldumb.h>

const int pan = 128;
const int volume = 128;

DUH* music[7];
SAMPLE* sample[2];

AL_DUH_PLAYER *dplay=NULL; /* Holds the current playback state. */


void stopmusic()
{
	//BASS_ChannelStop(curplay);
	if (dplay)
	{
		al_stop_duh(dplay);
		dplay=NULL;
	}
}

int curtrack=0;

void playmusic(int i)
{
	curtrack=i;
	stopmusic();

	dplay=al_start_duh(music[i],2,0,0.2f, 4096,2000);
}

void ultrahifi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,22000);
}

void hifi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,4000);
}

void midfi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,2000);
}


void lofi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,1000);
}


void ultralofi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,500);
}

void playsample(int i, int pitch=1000)
{
	play_sample(sample[i], volume, pan, pitch/20, 0);
}

void init_sound()
{

	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	atexit(&dumb_exit);
	set_mixer_quality(0);
	dumb_register_stdfiles();

	sample[0] = load_sample("wav/blip.wav");
	sample[1] = load_sample("wav/sound2.wav");

	//load music
	music[0] = dumb_load_xm_quick("xm/b1.xm");
	music[1] = dumb_load_xm_quick("xm/b2.xm");
	music[2] = dumb_load_xm_quick("xm/b3.xm");
	music[3] = dumb_load_xm_quick("xm/b4.xm");
	music[4] = dumb_load_xm_quick("xm/b5.xm");
	music[5] = dumb_load_xm_quick("xm/b6.xm");
	music[6] = dumb_load_xm_quick("xm/b7.xm");


}
